

import math
import random

from WordReader import WordReader

class Clustering:

    def __init__(self):
        clusterList = []
        totalDistance = 0
        
    # get the distance between two vectors/points
    def distance(self, point1, point2):
        # length should be the same
        assert(len(point1) == len(point2))
        total = 0;
        for i in range(len(point1)):
            total += ((point1[i] - point2[i]) * (point1[i] - point2[i]))

        return math.sqrt(total)

    #return the distance between two clusters
    def clusterDistance(self, cluster1, cluster2):
        return self.distance(cluster1.centroid(), cluster2.centroid())

    # this needs to be fixed
    def bestKMeans(self, dict):
        myCluster = Cluster()
        minDistance = 100000000000000
        
        for i in range(2,100):
            listsOfCategories = self.kmeans(dict, i)
            
            for category in range(len(listsOfCategories)):
                #print(startCategories[i])
                #print(dict[word])
                totalDistance = 0
                centerOfCategory = myCluster.centroid(category)

                for word in category:                
                    totalDistance += self.distance(centerOfCategory, word)

                if totalDistance < minDistance:
                    minDistance = totalDistance
                    bestK = i
            
        
    # implements the kMeans clustering algorythm
    def kMeans(self, dict, k):
        myCluster = Cluster()

        # algorithm
        # put all words in an initial category
        # find centroid
        # get total distance from centroid
        # get the error

        # put words in new category with centroid from last
        # find new centroid
        # do ten times.

        # pick n words to be our starting categories        
        randomPoints = self.chooseRandomStartPoints(dict, k)

        #get the n random words to start with
        startWords = randomPoints[0]
        #get the remaining words we don't start with as categories
        remainingWords = randomPoints[1]        
        
        
        
        #print("Here " + startCategories)
        # initial
        for word in remainingWords:
            wordCategoryIndex = -1
            minDistance = 100000000
            for i in range(len(startWords)):
                #print(startCategories[i])
                #print(dict[word])
                tempDist = self.distance(dict[word],
                                 myCluster.centroid(startWords[i], dict))
                if tempDist < minDistance:
                    minDistance = tempDist
                    wordCategoryIndex = i

            startWords[wordCategoryIndex].append(word)

        # here is the centroid of each category
        oldCentroid = []
        for category in startWords:
            #print("words = ", category)
            oldCentroid.append(myCluster.centroid(category, dict))
        
        for i in range(20):
            newCentroid = myCluster.centroid(dict.keys(), dict)
            categories = []
            for i in range(len(startWords)):
                categories.append([])
            
            # go through categories again to refine them.
        
            for word in dict.keys():
                wordCategory = -1
                minDistance = 100000000
                for i in range(len(startWords)):
                   #print(startCategories[i])
                    #print(dict[word])
                    tempDist = self.distance(dict[word], oldCentroid[i])
                    if tempDist < minDistance:
                        minDistance = tempDist
                        wordCategory = i
                #print(wordCategory)
                categories[wordCategory].append(word)
                
            oldCentroid = []
            for category in startWords:
                oldCentroid.append(myCluster.centroid(category, dict))
                    
        return categories
        
    # implements the hierarchical clustering algorythm
    # doesn't work yet
    def hierarchical(self, dict):
        keys = dict.keys
        for i in keys:
            for j in keys:
                point1 = dict.get(i)
                point2 = dict.get(i)
                if point1 != point2:
                    dist = distance(point1, point2)
                    # get minimum distance.

                    
        return 1
    def expectationMaximazation(self, dict):
        # start with random start points from data
        randomPoints = self.chooseRandomStartPoints(dict, k)

        #get the n random words to start with
        startWords = randomPoints[0]
        #get the remaining words we don't start with as categories
        remainingWords = randomPoints[1]

        
    
    # given a dictionary
    def chooseRandomStartPoints(self, dict, n):
        returnList = []
        keys = dict.keys()

        while (n > 0):
            item = random.choice(keys)
            returnList.append([item])
            keys.remove(item)
            n = n - 1

        return returnList, keys            


class Cluster:
    def __init__(self):
        dict = {}

    # pointList is a vector like the following: [[2,3,4,5,6],[3,4,6,8,0]]
    def centroid_helper(self, pointList):
        length = len(pointList[0])
        # create a list of the appropriate length with all zeroes:
        #  ex:  [0.0, 0.0, 0.0, 0.0]
        returnList = map((lambda x: 0.0), range(length))
        # assume that the length of all lists in this
        #    list are the same length as the first one.
        # loop through each coordinate and add up the different vectors
        for i in range(len(pointList)):
            for j in range(length):
                #print(pointList[i][j])
                returnList[j] = returnList[j] + pointList[i][j]
        # divide by the number of vectors
        return map((lambda x: x/len(pointList)), returnList)


    # this takes a list of words and an optional
    #  dictionary and returns the centroid
    def centroid(self, pointList, dict=None):
        if dict:
            # we have a list of words to get the center of
            #print("PointList = ", pointList)
            points = map(dict.get, pointList)
            return self.centroid_helper(points)
        else:
            # we simply have a list of points to get the center of
            # this one works
            return self.centroid_helper(pointList)


    

#class HierarchyCluster:
    
    
    
#clustering = Clustering()
#clusterObject = Cluster()
#wordReader = WordReader()
#words = wordReader.countWords("sawyr10.txt")
#words = wordReader.countWords("english.txt")
#print(clustering.distance([1,2], [4,5]))
#print(clusterObject.centroid([[1,2], [4,5]]))
#print("-------------------------------------")
#categories = clustering.kMeans(words, 6)
#for category in categories:
#    print(category)
#    print("----------------------------")



    


    
