

from Tkinter import *
from WordReader import WordReader
from Clustering import *
import string, os, tkFileDialog



class ClusteringApp(Frame):
    startFileDir = '.'
    fileTypes = [('All files', '*'), ('Text files',  '.txt .text')]
    fileName = ''
    currentCategoryNum=0
    currentWord=''
    wordsDictionary={}
    numCategories = 5

    def doOpen(self):
        self.fileName = self.openFileDialog()
        #self.doClustering()
        
    
    def doClustering(self):
        #self.message.set('Opening file ' + fileName)
        clustering = Clustering()
        clusterObject = Cluster()
        wordReader = WordReader()
        self.wordsDictionary = wordReader.countWords(self.fileName)
        #self.message.set('Clustering Words')
        self.categories = clustering.kMeans(self.wordsDictionary, self.numCategories)
        root.title(self.fileName)
        for word in self.categories[0]:
            self.wordListBox.insert(END, word)
        
    def openFileDialog(self): 
        if not self.openDialog:
           self.openDialog = tkFileDialog.Open(initialdir=self.startFileDir, 
                                  filetypes=self.fileTypes)
        return self.openDialog.show()        

    def _selectCategory(self, y):
        self.currentCategoryNum = self.categoryListBox.nearest(y)
        self.categoryListBox.select_clear(0,END)
        self.categoryListBox.select_set(self.currentCategoryNum)
        self.wordListBox.delete(0, END)
        for word in self.categories[self.currentCategoryNum]:
            self.wordListBox.insert(END, word)
        return 'break'

    def _selectWord(self, y):
        row = self.wordListBox.nearest(y)
        self.currentWord = self.categories[self.currentCategoryNum][row]
        self.wordListBox.select_clear(0,END)
        self.wordListBox.select_set(row)
        #self.dataListBox.delete(0, END)
        self.message.set(self.wordsDictionary[self.currentWord])
        #self.currentWord
        #for num in self.wordsDictionary[self.currentWord]:
        #    self.dataListBox.insert(END, num)
        return 'break'
        
    def createWidgets(self):

        self.clusterButton = Button(self)
        self.clusterButton["text"] = "Cluster",
        self.clusterButton["command"] = self.doClustering
        self.clusterButton.pack({"side": "left"})
        
        self.plotButton = Button(self)
        self.plotButton["text"] = "Plot",
        self.plotButton["command"] = self.plot
        self.plotButton.pack({"side": "right"})

        

        # insert menu bar
        menuBar = Menu(self.root)
        self.root.config(menu=menuBar)
        
        # Create entries in "File" menu
        fileMenu = Menu(menuBar)
        menuBar.add_cascade(label='File', menu=fileMenu)
        fileMenu.add_command(label='Open', command=self.doOpen)
        fileMenu.add_separator()
        fileMenu.add_command(label='Quit', command=sys.exit)

        self.message = StringVar(root)
        informationLabel = Label(self.root, textvariable=self.message)
        informationLabel.pack(side = BOTTOM)
        
        self.plotCanvas = Canvas(self.root)
        self.plotCanvas.pack(side=BOTTOM, fill=BOTH, expand=1)
        
        # Create Listbox
        self.categoryListBox = Listbox(root, selectmode=SINGLE)
        self.categoryListBox.bind('<Button-1>', lambda e, s=self: s._selectCategory(e.y))
        self.categoryListBox.pack(side=LEFT, fill=Y, expand=1)
        for i in range(self.numCategories):
            self.categoryListBox.insert(END, i)

        scrollbar = Scrollbar(self.root, orient=VERTICAL)
        self.wordListBox = Listbox(self.root, selectmode=SINGLE, yscrollcommand=scrollbar.set)
        self.wordListBox.bind('<Button-1>', lambda e, s=self: s._selectWord(e.y))
        scrollbar.config(command=self.wordListBox.yview)
        scrollbar.pack(side=RIGHT, fill=Y)
        self.wordListBox.pack(side=LEFT, fill=Y, expand=1)
        #for i in range(20):
        #    self.wordListBox.insert(END, i)

        #self.dataListBox = Listbox(root)
        #self.dataListBox.pack(side=RIGHT)
        self.message.set('Welcome')
        # Create Databox
        
        
        
        #self.list

    def minimax(self, values=[0.0, 1.0, 0.0, 1.0]):
        "Adjust and display X and Y bounds"
        
        maxX = self.myMax(self.wordsDictionary, 0) * 1.0
        maxY = self.myMax(self.wordsDictionary, 1) * 1.0
        
        returnVal = [0.0, maxX, 0.0, maxY]
        #print returnVal
        return returnVal

    def myMax(self, dict, elementNum):
        max = -1
        for item in dict.values():
            if item[elementNum] > max:
                max = item[elementNum]                     
        return max

    def plot(self):
        #print("plotting")
        "Plot given function with given bounds"
        minx, maxx, miny, maxy = self.minimax()

        
        if maxy == 0.0 :
            maxy == 1.0
        if maxx == 0.0 :
            maxx == 1.0
        if minx == 0.0 :
            minx == 1.0
        if miny == 0.0 :
            miny == 1.0

        print(maxy)            
            
        # get canvas x and y dimensions
        canvasWidth = self.plotCanvas.winfo_width() * 1.0 - 10.0
        canvasHeight = self.plotCanvas.winfo_height() * 1.0 - 10.0
      
        #print(canvasWidth, canvasHeight)
        
        self.plotCanvas.delete(ALL)
        # compute coordinates for line
        coords = [ ]

        colors = ["darkgreen", "blue",  "orange", "red", "darkgray", "purple", "yellow",]
        for i in range(len(self.categories)):
            for word in self.categories[i]:
                pointX = self.wordsDictionary[word][0]
                pointY = self.wordsDictionary[word][1]
              
                x = (pointX * canvasWidth)/maxx
                y = canvasHeight - (canvasHeight) * (pointY)/maxy + 6
                #print(x,y)
                self.plotCanvas.create_text(x, y, text=i, fill=colors[i])
                #self.plotCanvas.create_arc(x, y, x+10, y+10, fill=colors[i])
                
        #for point in self.wordsDictionary.values():
            

            #self.plotCanvas.create_line(x, y, x+1, y+1)
            #coords.append(x)
            #coords.append(y)
            
            #print(x,y)
        #print(coords)
        # draw line
        
        

        
    def __init__(self, master=None):
        Frame.__init__(self, master)
        self.openDialog = None
        self.root = master
        self.pack()
        self.createWidgets()

    
    
root = Tk()
app = ClusteringApp(root)

app.mainloop()


